/*
	TrayIconCtlApplet
	Copyright (C) 2004 ONO, Masayuki <mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "trayiconctlapplet.h"
#include "trayiconimpl.h"

TrayIconCtlApplet::TrayIconCtlApplet()
    : m_pTrayIcon(0), ref(0)
{
}

TrayIconCtlApplet::~TrayIconCtlApplet()
{
	if ( m_pTrayIcon )
	{
    	delete m_pTrayIcon;
		m_pTrayIcon = NULL;
	}
}

QWidget* TrayIconCtlApplet::applet( QWidget* parent )
{
	if ( m_pTrayIcon == NULL )
	{
		m_pTrayIcon = new CTrayIconImpl( parent );
	}
	return m_pTrayIcon;
}

int TrayIconCtlApplet::position() const
{
	return 6;
}

QRESULT TrayIconCtlApplet::queryInterface( const QUuid& uuid, QUnknownInterface** iface )
{
	QRESULT rel;

	if ( uuid == IID_QUnknown || uuid == IID_TaskbarApplet )
	{
		*iface = this;
	    (*iface)->addRef();
		rel = QS_OK;
	}
    else
	{
		*iface = 0;
		rel = QS_FALSE;
	}

	return rel;
}

Q_EXPORT_INTERFACE()
{
    Q_CREATE_INSTANCE( TrayIconCtlApplet )
}


