/*
	TrayIconCtlApplet
	Copyright (C) 2003 ONO,Masayuki.<mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef __TRAY_ICON_IMPL_H__
#define __TRAY_ICON_IMPL_H__

#include <qwidget.h>
#include <qpixmap.h>
#include <qpopupmenu.h>
#include <qpainter.h>
#include <qdatetime.h>
#include <qtimer.h>
#include <qfileinfo.h>
#include <qwindowsystem_qws.h>
#include <qpe/qcopenvelope_qws.h>
#include <qpe/qpeapplication.h>
#include <qpe/global.h>
#include <qpe/resource.h>
#include <qpe/config.h>

static const int nIconMax = 4;

class TRAYICONDATA
{
public:
	TRAYICONDATA();
	virtual ~TRAYICONDATA(){}

	void init();
	void save();
	void add( const QString&, const QString& );
	void modify( const QString&, const QString& );
	void setRemoveWith( const QString&, const int );
	void setRemoveAfter( const QString&, const int );
	bool sweep();
	bool sweep2();
	void remove( const QString& );
	void clear();
	void draw( QPainter* );
	QSize size();
private:
	struct {
	QPixmap			pix;
	QString			name;
	QString			path;
	QDateTime		vanishtime;
	int				p_id;
	} m_Icon[ nIconMax ];
};

class CTrayIconImpl : public QWidget
{
	Q_OBJECT
public:
    CTrayIconImpl( QWidget * );
    virtual ~CTrayIconImpl();

protected:
    void mouseReleaseEvent( QMouseEvent* );
    void paintEvent( QPaintEvent* );
protected slots:
	void receiveMessage( const QCString&, const QByteArray& );

private:
	void version();
private slots:
	void removeTimer();
	void sweepTimer();
	void menuAction( int );

private:
	int m_nInterval;
	TRAYICONDATA m_rData;

protected:
	QTimer* m_pSweeper;
	QCopChannel* m_pChannel;
};

#endif /* __TRAY_ICON_IMPL_H__ */
